package com.yice.webadmin.app.controller;

import com.github.pagehelper.page.PageMethod;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.yice.common.core.annotation.MyRequestBody;
import com.yice.common.core.constant.ErrorCodeEnum;
import com.yice.common.core.object.*;
import com.yice.common.core.util.MyCommonUtil;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.core.util.MyPageUtil;
import com.yice.common.log.annotation.OperationLog;
import com.yice.common.log.model.constant.SysOperationLogType;
import com.yice.webadmin.app.dto.PluginManageDto;
import com.yice.webadmin.app.model.PluginManage;
import com.yice.webadmin.app.service.PluginManageService;
import com.yice.webadmin.app.vo.PluginManageVo;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 插件编排管理接口。
 *
 * @author linking
 * @date 2023-04-13
 */
@Api(tags = "插件编排管理接口")
@Slf4j
@RestController
@RequestMapping("/admin/app/pluginManage")
public class PluginManageController {

    @Autowired
    private PluginManageService pluginManageService;

    /**
     * 新增知识图谱管理数据。
     *
     * @param pluginManageDto 新增对象。
     * @return 应答结果对象，包含新增对象主键Id。
     */
    @ApiOperationSupport(ignoreParameters = {"pluginManageDto.pluginId"})
    @OperationLog(type = SysOperationLogType.ADD)
    @PostMapping("/add")
    public ResponseResult<Long> add(@MyRequestBody PluginManageDto pluginManageDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(pluginManageDto, false);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        PluginManage pluginManage = MyModelUtil.copyTo(pluginManageDto, PluginManage.class);
        pluginManage = pluginManageService.saveNew(pluginManage);
        return ResponseResult.success(pluginManage.getPluginId());
    }

    /**
     * 更新知识图谱管理数据。
     *
     * @param pluginManageDto 更新对象。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.UPDATE)
    @PostMapping("/update")
    public ResponseResult<Void> update(@MyRequestBody PluginManageDto pluginManageDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(pluginManageDto, true);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        PluginManage pluginManage = MyModelUtil.copyTo(pluginManageDto, PluginManage.class);
        PluginManage originalPluginManage = pluginManageService.getById(pluginManage.getPluginId());
        if (originalPluginManage == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [数据] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!pluginManageService.update(pluginManage, originalPluginManage)) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        return ResponseResult.success();
    }

    /**
     * 删除知识图谱管理数据。
     *
     * @param pluginId 删除对象主键Id。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.DELETE)
    @PostMapping("/delete")
    public ResponseResult<Void> delete(@MyRequestBody Long pluginId) {
        if (MyCommonUtil.existBlankArgument(pluginId)) {
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST);
        }
        return this.doDelete(pluginId);
    }

    /**
     * 批量删除知识图谱管理数据。
     *
     * @param pluginIdList 待删除对象的主键Id列表。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.DELETE_BATCH)
    @PostMapping("/deleteBatch")
    public ResponseResult<Void> deleteBatch(@MyRequestBody List<Long> pluginIdList) {
        if (MyCommonUtil.existBlankArgument(pluginIdList)) {
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST);
        }
        for (Long pluginId : pluginIdList) {
            ResponseResult<Void> responseResult = this.doDelete(pluginId);
            if (!responseResult.isSuccess()) {
                return responseResult;
            }
        }
        return ResponseResult.success();
    }

    /**
     * 列出符合过滤条件的知识图谱管理列表。
     *
     * @param pluginManageDtoFilter 过滤对象。
     * @param orderParam 排序参数。
     * @param pageParam 分页参数。
     * @return 应答结果对象，包含查询结果集。
     */
    @PostMapping("/list")
    public ResponseResult<MyPageData<PluginManageVo>> list(
            @MyRequestBody PluginManageDto pluginManageDtoFilter,
            @MyRequestBody MyOrderParam orderParam,
            @MyRequestBody MyPageParam pageParam) {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        PluginManage pluginManageFilter = MyModelUtil.copyTo(pluginManageDtoFilter, PluginManage.class);
        String orderBy = MyOrderParam.buildOrderBy(orderParam, PluginManage.class);
        List<PluginManage> pluginManageList =
                pluginManageService.getPluginManageListWithRelation(pluginManageFilter, orderBy);
        return ResponseResult.success(MyPageUtil.makeResponseData(pluginManageList, PluginManage.INSTANCE));
    }

    /**
     * 查看指定知识图谱管理对象详情。
     *
     * @param pluginId 指定对象主键Id。
     * @return 应答结果对象，包含对象详情。
     */
    @GetMapping("/view")
    public ResponseResult<PluginManageVo> view(@RequestParam Long pluginId) {
        PluginManage pluginManage = pluginManageService.getByIdWithRelation(pluginId, MyRelationParam.full());
        if (pluginManage == null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        PluginManageVo pluginManageVo = MyModelUtil.copyTo(pluginManage, PluginManageVo.class);
        return ResponseResult.success(pluginManageVo);
    }

    private ResponseResult<Void> doDelete(Long pluginId) {
        String errorMessage;
        // 验证关联Id的数据合法性
        PluginManage originalPluginManage = pluginManageService.getById(pluginId);
        if (originalPluginManage == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [对象] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!pluginManageService.remove(pluginId)) {
            errorMessage = "数据操作失败，删除的对象不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        return ResponseResult.success();
    }
}
